#include <ESP8266WiFi.h>
#include <ESP8266mDNS.h>
#include <WiFiUdp.h>
#include <ArduinoOTA.h>

const char* ssid = "dougswap";
const char* password = "fusordoug";
int errors;

WiFiUDP tport;
WiFiUDP dport;
char packetBuffer[255];
#define DNSPORT 53831 // landns UDP port
#define DATAPORT 42042 // port for PC communication

IPAddress myip; // my ip as assigned by dhcp
IPAddress bcip; // broadcast addr for this network
unsigned char mac[6]; // my mac, I hope
char tellem_string[40]; // What we'll broadcast
int packetSize; //incoming size info

unsigned long tellems;
unsigned long loop_millis;
#define MINUTE_MS 60000
unsigned long minute_z; // milliseconds since last tell



////////////////////////////////////
void init_ram ()
{
  tellems = errors = 0;
  minute_z = millis();
  
}
////////////////////////////////////
///////////////////////////////////
void build_tellem_string ()
{
  int i;
  String mystring;

//@@@ class String can't 0 pad hex...
// but sprintf and strncpy are lots more lines of code (less rom though)
  mystring = myip.toString();
  mystring += " ESP_";
  for (i=3;i<6;i++) 
  {
    if (16 > mac[i]) mystring += "0"; // yes, it is that dumb    
    mystring += String(mac[i],HEX);
   }
   mystring += "_BR1";
  mystring.toUpperCase(); // because damn, that's what it is on the net for some retarded opsys
  mystring.toCharArray(tellem_string, 39);
}
////////////////////////////////////
void tellem()
{
  tport.beginPacket(bcip,DNSPORT);
  tport.write(tellem_string);
  tport.endPacket(); 
  tellems++; // for grins, count them
//  Serial.println(tellem_string);
}
////////////////////////////////////
////////////////////////////////////
void ditch_incoming()
{ // ignore other broadcasts, maybe stop possible memory leak.
  // You MUST do this with other things on the LAN broadcasting
  // or library loses its mind - 
  packetSize = tport.parsePacket();
  if (packetSize) {
    int len = tport.read(packetBuffer, 254);
  }
}
////////////////////////////////////
void setup() {
  Serial.begin(115200);
  Serial.println("Booting");
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  while (WiFi.waitForConnectResult() != WL_CONNECTED) {
 //   Serial.println("Connection Failed! Rebooting..."); // no printing as we're using the port for the power supply
    delay(5000);
    ESP.restart();
  }

  WiFi.macAddress(mac); // get my MAC addr, as it's part of hostname
  myip = WiFi.localIP(); // class and union of dword and 4 bytes
  bcip = myip; // copy net address but
  bcip[3] = 255; // make it broadcast address
  build_tellem_string();
  init_ram();
  tport.begin(DNSPORT); // for tellem
  delay(300);
  ArduinoOTA.begin();
  Serial.println("Ready");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());

  
}

void loop() {

  loop_millis = millis(); // just do this once
  if (loop_millis - minute_z >= MINUTE_MS)
  {
    minute_z = loop_millis; // update for next time
    tellem(); // 1/minute stuff
    yield();
  } //
  
  ditch_incoming(); // must do this or library leaks memory and dies
  yield();
  ArduinoOTA.handle();

  // test serial port output
  Serial.print(errors++);
  Serial.println (" A bunch of other bits to see which pin the port output is on...");
  delay (1000);
}
